summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorDavid Abbott2010-07-21 05:51:00 (GMT)
committerDavid Abbott2010-07-21 05:51:00 (GMT)
commite3d3f1285b1b68f9ff3fa350ed47a0a3673de801 (patch)
tree9208c2d42e1f992e1a505e63301fe0233c4a02c5
parent438ff7a93a50a9c02c40521f2af66b6276a6a160 (diff)
Initial commit to test patchset for Bug 328939 fixups
(Portage version: 2.2_rc67/git/Linux x86_64) (Signed Manifest commit)
-rw-r--r--mail-filter/spamassassin/ChangeLog11
-rw-r--r--mail-filter/spamassassin/Manifest18
-rw-r--r--mail-filter/spamassassin/files/3.0.0-spamd.conf46
-rw-r--r--mail-filter/spamassassin/files/3.3.1-spamd.init46
-rw-r--r--mail-filter/spamassassin/files/secrets.cf14
-rw-r--r--mail-filter/spamassassin/files/spamassassin-3.3.1-PERL-5-12.patch240
-rw-r--r--mail-filter/spamassassin/metadata.xml13
-rw-r--r--mail-filter/spamassassin/spamassassin-3.3.1-r3.ebuild202
8 files changed, 590 insertions, 0 deletions
diff --git a/mail-filter/spamassassin/ChangeLog b/mail-filter/spamassassin/ChangeLog
new file mode 100644
index 0000000..5bb685b
--- /dev/null
+++ b/mail-filter/spamassassin/ChangeLog
@@ -0,0 +1,11 @@
+# ChangeLog for mail-filter/spamassassin
+# Copyright 1999-2010 Gentoo Foundation; Distributed under the GPL v2
+# $Header: $
+
+*spamassassin-3.3.1-r3 (21 Jul 2010)
+
+ 21 Jul 2010; David Abbott <dabbott@gentoo.org> +files/3.0.0-spamd.conf,
+ +spamassassin-3.3.1-r3.ebuild, +files/spamassassin-3.3.1-PERL-5-12.patch,
+ +files/3.3.1-spamd.init, +files/secrets.cf, +metadata.xml:
+ Initial commit to test patches for Bug 328939
+
diff --git a/mail-filter/spamassassin/Manifest b/mail-filter/spamassassin/Manifest
new file mode 100644
index 0000000..d6a1240
--- /dev/null
+++ b/mail-filter/spamassassin/Manifest
@@ -0,0 +1,18 @@
+-----BEGIN PGP SIGNED MESSAGE-----
+Hash: SHA1
+
+AUX 3.0.0-spamd.conf 1527 RMD160 8075268aecdf6f41f5cdacb683fe92567d860dae SHA1 01623333cecb1ef38b25a130d3b5afe016e70f1c SHA256 ea61041e8b6b1616ec096cc42245ab8442b962f72c318695f5acff1fd794ee34
+AUX 3.3.1-spamd.init 932 RMD160 9a987db6e5280b9024e1591ad9f5abb8525bae37 SHA1 d9d52d7e6c3f1cd1b14eda60d8739bdfdbe7c6e9 SHA256 a73a201506e27e5c4654d0ed856fdfb6d22f4f3ae8ead780fbcd8a5b70907b39
+AUX secrets.cf 664 RMD160 afb1212a464bd7053c1301c1a1e670b73216528a SHA1 a742beddf850e55bc4454a7548dc43c36f8e9760 SHA256 9f134c7b857b21689f612fc6d131f719e5a65e2ba341b282e7aa57402c854139
+AUX spamassassin-3.3.1-PERL-5-12.patch 9991 RMD160 0817a54b005eab1e36b361092cb4ad2033d92667 SHA1 085dd6ca9f895d4793b39b4ad25095a1b56565cc SHA256 6d4a80a12a811f6a2ba8c6f3128ef5591e7bfeb792dcb0a3570b276edb912966
+DIST Mail-SpamAssassin-3.3.1.tar.bz2 1015008 RMD160 b681fc60292cd30efd405585aad70f39c9633260 SHA1 f5748043eb286b1acb456093039a55db00c6f25e SHA256 4c348cd951fc2c5688e9713fcbc6ba453df51d32a1ab332a63800d20ff18bdb4
+EBUILD spamassassin-3.3.1-r3.ebuild 6586 RMD160 6af405a3f6104988d2637cc7bd1fb11f2a2a7591 SHA1 14b1c6810eb4604fcf2b9a573154d31149f72213 SHA256 6547d4bca7168054292d04617f55ad90631e152282d366e58b652e1be2f80137
+MISC ChangeLog 423 RMD160 5b5052fab9ef469e85f5ab2db2bc80a733375975 SHA1 9656594a1db81efa30cfa3ad5209c42e00b82358 SHA256 fbd9fffc4b108beb0c77cb4933da31621280d576d96d1bd188e2cd9a96af37df
+MISC metadata.xml 339 RMD160 d26879faaf735d1ca3001a1c61ab472b14789420 SHA1 8b21003a4404ada77b2a9bf2a3fa1733e46fe352 SHA256 140cb2839ea50486116c578fe574b9090de04c483c2c7bce792dfa7e21138aa5
+-----BEGIN PGP SIGNATURE-----
+Version: GnuPG v2.0.15 (GNU/Linux)
+
+iEYEARECAAYFAkxGisMACgkQcZ+z4vAcSsw6xwCeOxSHOC9SEEl2YyGS2QbLXdW6
+Dd8AnjfC4bxlCjHCq3oEBkWbwylbaOhr
+=cDJO
+-----END PGP SIGNATURE-----
diff --git a/mail-filter/spamassassin/files/3.0.0-spamd.conf b/mail-filter/spamassassin/files/3.0.0-spamd.conf
new file mode 100644
index 0000000..b6fca03
--- /dev/null
+++ b/mail-filter/spamassassin/files/3.0.0-spamd.conf
@@ -0,0 +1,46 @@
+# Config file for /etc/init.d/spamd
+
+
+# ***WARNING***
+# spamd was not designed to listed to an untrusted network. spamd
+# is vulnerable to DoS attacks (and eternal doom) if used to listen
+# to an untrusted network.
+#
+
+
+# Some options:
+#
+# -c to create a per user configuration file
+# -H [dir] to switch home dirs for helper apps, dir optional
+# -i [ip] to listen on the specified IP,
+# 127.0.0.1 if omitted,
+# 0.0.0.0 (ie. all) if given without value;
+# must be used in combination with -A to actually allow
+# connections from anybody but localhost
+# -m limit to set the number of children, default 5
+# -u user the user to run spamd as
+# -L if you want to run no net tests
+#
+# for more help look in man spamd
+#
+# Note: if you plan on using the -u flag to spamd you will need to
+# make sure the location of the PID file is writable by that user.
+# This can be done by making the directory /var/run/spamd and
+# changing the owner to the UID that runs spamd. You will then
+# need to edit $pidfile in /etc/init.d/spamd. This should fix the
+# problem with stop/restart in the init scripts.
+#
+# See http://bugs.gentoo.org/show_bug.cgi?id=70124 for a full
+# explanation.
+
+SPAMD_OPTS="-m 5 -c -H"
+
+# spamd stores its pid in this file. If you use the -u option to
+# run spamd under another user, you might need to adjust it.
+
+PIDFILE="/var/run/spamd.pid"
+
+# SPAMD_NICELEVEL lets you set the 'nice'ness of the running
+# spamd process
+
+# SPAMD_NICELEVEL=5
diff --git a/mail-filter/spamassassin/files/3.3.1-spamd.init b/mail-filter/spamassassin/files/3.3.1-spamd.init
new file mode 100644
index 0000000..6d21acb
--- /dev/null
+++ b/mail-filter/spamassassin/files/3.3.1-spamd.init
@@ -0,0 +1,46 @@
+#!/sbin/runscript
+# Copyright 1999-2008 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: $
+
+# NB: Config is in /etc/conf.d/spamd
+
+# Provide a default location if they haven't in /etc/conf.d/spamd
+PIDFILE=${PIDFILE:-/var/run/spamd.pid}
+
+opts="reload"
+
+depend() {
+ need net
+ before mta
+ use logger
+@USEPOSTGRES@ use postgresql
+@USEMYSQL@ use mysql
+}
+
+start() {
+ ebegin "Starting spamd"
+ start-stop-daemon --start --quiet \
+ --name spamd \
+ --nicelevel ${SPAMD_NICELEVEL:-0} \
+ --pidfile ${PIDFILE} \
+ --exec /usr/sbin/spamd -- -d -r ${PIDFILE} \
+ ${SPAMD_OPTS}
+ retval=$?
+ if ! [ -f "${PIDFILE}" ]; then
+ sleep 1
+ fi
+ eend ${retval} "Failed to start spamd"
+}
+
+stop() {
+ ebegin "Stopping spamd"
+ start-stop-daemon --stop --quiet --pidfile ${PIDFILE}
+ eend $? "Failed to stop spamd"
+}
+
+reload() {
+ ebegin "Reloading configuration"
+ kill -HUP $(< ${PIDFILE})
+ eend $?
+}
diff --git a/mail-filter/spamassassin/files/secrets.cf b/mail-filter/spamassassin/files/secrets.cf
new file mode 100644
index 0000000..efa31a6
--- /dev/null
+++ b/mail-filter/spamassassin/files/secrets.cf
@@ -0,0 +1,14 @@
+# The below sample from bug 91430 is an example of using mysql
+# for spam filter storage
+
+#(Tell Spamassissin to use MySQL for bayes data
+#bayes_store_module Mail::SpamAssassin::BayesStore::SQL
+#bayes_sql_dsn DBI:mysql:sa_bayes:localhost:3306
+#bayes_sql_username db_name
+#bayes_sql_password another_very_secret_password
+
+#(Tell Spamassissin to use MySQL for AWL data
+#auto_whitelist_factory Mail::SpamAssassin::SQLBasedAddrList
+#user_awl_dsn DBI:mysql:sa_bayes:localhost:3306
+#user_awl_sql_username db_name
+#user_awl_sql_password another_very_secret_password
diff --git a/mail-filter/spamassassin/files/spamassassin-3.3.1-PERL-5-12.patch b/mail-filter/spamassassin/files/spamassassin-3.3.1-PERL-5-12.patch
new file mode 100644
index 0000000..ca4f9c9
--- /dev/null
+++ b/mail-filter/spamassassin/files/spamassassin-3.3.1-PERL-5-12.patch
@@ -0,0 +1,240 @@
+diff -ur a/Mail-SpamAssassin-3.3.1//lib/Mail/SpamAssassin/Dns.pm b/Mail-SpamAssassin-3.3.1//lib/Mail/SpamAssassin/Dns.pm
+--- a/Mail-SpamAssassin-3.3.1//lib/Mail/SpamAssassin/Dns.pm 2010-03-16 10:49:21.000000000 -0400
++++ b/Mail-SpamAssassin-3.3.1//lib/Mail/SpamAssassin/Dns.pm 2010-07-20 15:54:23.000000000 -0400
+@@ -754,7 +754,7 @@
+ dbg("dns: entering helper-app run mode");
+ $self->{old_slash} = $/; # Razor pollutes this
+ %{$self->{old_env}} = ();
+- if ( defined %ENV ) {
++ if ( %ENV ) {
+ # undefined values in %ENV can result due to autovivification elsewhere,
+ # this prevents later possible warnings when we restore %ENV
+ while (my ($key, $value) = each %ENV) {
+Only in b/Mail-SpamAssassin-3.3.1//lib/Mail/SpamAssassin: Dns.pm~
+diff -ur a/Mail-SpamAssassin-3.3.1//lib/Mail/SpamAssassin/HTML.pm b/Mail-SpamAssassin-3.3.1//lib/Mail/SpamAssassin/HTML.pm
+--- a/Mail-SpamAssassin-3.3.1//lib/Mail/SpamAssassin/HTML.pm 2010-03-16 10:49:21.000000000 -0400
++++ b/Mail-SpamAssassin-3.3.1//lib/Mail/SpamAssassin/HTML.pm 2010-07-20 15:52:50.000000000 -0400
+@@ -191,7 +191,7 @@
+ my $self = shift;
+ my %options = @_;
+
+- return join('', @{ $self->{text} }) unless keys %options;
++ return join('', @{ $self->{text} }) unless %options;
+
+ my $mask;
+ while (my ($k, $v) = each %options) {
+Only in b/Mail-SpamAssassin-3.3.1//lib/Mail/SpamAssassin: HTML.pm~
+diff -ur a/Mail-SpamAssassin-3.3.1//lib/Mail/SpamAssassin/Plugin/BodyEval.pm b/Mail-SpamAssassin-3.3.1//lib/Mail/SpamAssassin/Plugin/BodyEval.pm
+--- a/Mail-SpamAssassin-3.3.1//lib/Mail/SpamAssassin/Plugin/BodyEval.pm 2010-03-16 10:49:21.000000000 -0400
++++ b/Mail-SpamAssassin-3.3.1//lib/Mail/SpamAssassin/Plugin/BodyEval.pm 2010-07-20 16:04:57.000000000 -0400
+@@ -119,7 +119,7 @@
+ }
+
+ # If there are no words, mark if there's at least 1 image ...
+- if (keys %html == 0 && exists $pms->{html}{inside}{img}) {
++ if (!%html && exists $pms->{html}{inside}{img}) {
+ # Use "\n" as the mark since it can't ever occur normally
+ $html{"\n"}=1;
+ }
+Only in b/Mail-SpamAssassin-3.3.1//lib/Mail/SpamAssassin/Plugin: BodyEval.pm~
+Only in b/Mail-SpamAssassin-3.3.1//lib/Mail/SpamAssassin/Plugin: check.patch
+diff -ur a/Mail-SpamAssassin-3.3.1//lib/Mail/SpamAssassin/Plugin/Check.pm b/Mail-SpamAssassin-3.3.1//lib/Mail/SpamAssassin/Plugin/Check.pm
+--- a/Mail-SpamAssassin-3.3.1//lib/Mail/SpamAssassin/Plugin/Check.pm 2010-03-16 10:49:21.000000000 -0400
++++ b/Mail-SpamAssassin-3.3.1//lib/Mail/SpamAssassin/Plugin/Check.pm 2010-07-20 16:03:00.000000000 -0400
+@@ -307,64 +307,51 @@
+ my $package_name = __PACKAGE__;
+ my $methodname = $package_name."::_".$ruletype."_tests_".$clean_priority;
+
+- if (defined &{$methodname} && !$doing_user_rules) {
+-run_compiled_method:
+- # dbg("rules: run_generic_tests - calling %s", $methodname);
+- my $t = Mail::SpamAssassin::Timeout->new({ deadline => $master_deadline });
+- my $err = $t->run(sub {
+- no strict "refs";
+- $methodname->($pms, @{$opts{args}});
+- });
+- if ($t->timed_out() && $master_deadline && time > $master_deadline) {
+- info("check: exceeded time limit in $methodname, skipping further tests");
+- $pms->{deadline_exceeded} = 1;
+- }
+- return;
+- }
++ if (!defined &{$methodname} || $doing_user_rules) {
+
+- # use %nopts for named parameter-passing; it's more friendly to future-proof
+- # subclassing, since new parameters can be added without breaking third-party
+- # subclassed implementations of this plugin.
+- my %nopts = (
+- ruletype => $ruletype,
+- doing_user_rules => $doing_user_rules,
+- priority => $priority,
+- clean_priority => $clean_priority
+- );
+-
+- # build up the eval string...
+- $self->{evalstr_methodname} = $methodname;
+- $self->{evalstr_chunk_current_methodname} = undef;
+- $self->{evalstr_chunk_methodnames} = [];
+- $self->{evalstr_chunk_prefix} = []; # stack (array) of source code sections
+- $self->{evalstr} = ''; $self->{evalstr_l} = 0;
+- $self->{evalstr2} = '';
+- $self->begin_evalstr_chunk($pms);
+-
+- $self->push_evalstr_prefix($pms, '
+- # start_rules_plugin_code '.$ruletype.' '.$priority.'
+- my $scoresptr = $self->{conf}->{scores};
+- ');
+- if (defined $opts{pre_loop_body}) {
+- $opts{pre_loop_body}->($self, $pms, $conf, %nopts);
+- }
+- $self->add_evalstr($pms,
+- $self->start_rules_plugin_code($ruletype, $priority) );
+- while (my($rulename, $test) = each %{$opts{testhash}->{$priority}}) {
+- $opts{loop_body}->($self, $pms, $conf, $rulename, $test, %nopts);
+- }
+- if (defined $opts{post_loop_body}) {
+- $opts{post_loop_body}->($self, $pms, $conf, %nopts);
+- }
++ # use %nopts for named parameter-passing; it's more friendly
++ # to future-proof subclassing, since new parameters can be added without
++ # breaking third-party subclassed implementations of this plugin.
++ my %nopts = (
++ ruletype => $ruletype,
++ doing_user_rules => $doing_user_rules,
++ priority => $priority,
++ clean_priority => $clean_priority
++ );
++
++ # build up the eval string...
++ $self->{evalstr_methodname} = $methodname;
++ $self->{evalstr_chunk_current_methodname} = undef;
++ $self->{evalstr_chunk_methodnames} = [];
++ $self->{evalstr_chunk_prefix} = []; # stack (array) of source code sections
++ $self->{evalstr} = ''; $self->{evalstr_l} = 0;
++ $self->{evalstr2} = '';
++ $self->begin_evalstr_chunk($pms);
++
++ $self->push_evalstr_prefix($pms, '
++ # start_rules_plugin_code '.$ruletype.' '.$priority.'
++ my $scoresptr = $self->{conf}->{scores};
++ ');
++ if (defined $opts{pre_loop_body}) {
++ $opts{pre_loop_body}->($self, $pms, $conf, %nopts);
++ }
++ $self->add_evalstr($pms,
++ $self->start_rules_plugin_code($ruletype, $priority) );
++ while (my($rulename, $test) = each %{$opts{testhash}->{$priority}}) {
++ $opts{loop_body}->($self, $pms, $conf, $rulename, $test, %nopts);
++ }
++ if (defined $opts{post_loop_body}) {
++ $opts{post_loop_body}->($self, $pms, $conf, %nopts);
++ }
+
+- $self->flush_evalstr($pms, 'run_generic_tests');
+- $self->free_ruleset_source($pms, $ruletype, $priority);
++ $self->flush_evalstr($pms, 'run_generic_tests');
++ $self->free_ruleset_source($pms, $ruletype, $priority);
+
+- # clear out a previous version of this method
+- undef &{$methodname};
++ # clear out a previous version of this method
++ undef &{$methodname};
+
+- # generate the loop that goes through each line...
+- my $evalstr = <<"EOT";
++ # generate the loop that goes through each line...
++ my $evalstr = <<"EOT";
+ {
+ package $package_name;
+
+@@ -373,40 +360,51 @@
+ sub $methodname {
+ EOT
+
+- for my $chunk_methodname (@{$self->{evalstr_chunk_methodnames}}) {
+- $evalstr .= " $chunk_methodname(\@_);\n";
+- }
++ for my $chunk_methodname (@{$self->{evalstr_chunk_methodnames}}) {
++ $evalstr .= " $chunk_methodname(\@_);\n";
++ }
+
+- $evalstr .= <<"EOT";
++ $evalstr .= <<"EOT";
+ }
+
+ 1;
+ }
+ EOT
+
+- delete $self->{evalstr}; # free up some RAM before we eval()
+- delete $self->{evalstr2};
+- delete $self->{evalstr_methodname};
+- delete $self->{evalstr_chunk_current_methodname};
+- delete $self->{evalstr_chunk_methodnames};
+- delete $self->{evalstr_chunk_prefix};
+-
+- dbg("rules: run_generic_tests - compiling eval code: %s, priority %s",
+- $ruletype, $priority);
+-# dbg("rules: eval code to compile: $evalstr");
+- my $eval_result;
+- { my $timer = $self->{main}->time_method('compile_gen');
+- $eval_result = eval($evalstr);
+- }
+- if (!$eval_result) {
+- my $eval_stat = $@ ne '' ? $@ : "errno=$!"; chomp $eval_stat;
+- warn "rules: failed to compile $ruletype tests, skipping:\n".
+- "\t($eval_stat)\n";
+- $pms->{rule_errors}++;
+- }
+- else {
++ delete $self->{evalstr}; # free up some RAM before we eval()
++ delete $self->{evalstr2};
++ delete $self->{evalstr_methodname};
++ delete $self->{evalstr_chunk_current_methodname};
++ delete $self->{evalstr_chunk_methodnames};
++ delete $self->{evalstr_chunk_prefix};
++
++ dbg("rules: run_generic_tests - compiling eval code: %s, priority %s",
++ $ruletype, $priority);
++ # dbg("rules: eval code to compile: $evalstr");
++ my $eval_result;
++ { my $timer = $self->{main}->time_method('compile_gen');
++ $eval_result = eval($evalstr);
++ }
++ if (!$eval_result) {
++ my $eval_stat = $@ ne '' ? $@ : "errno=$!"; chomp $eval_stat;
++ warn "rules: failed to compile $ruletype tests, skipping:\n".
++ "\t($eval_stat)\n";
++ $pms->{rule_errors}++;
++ return;
++ }
+ dbg("rules: compiled $ruletype tests");
+- goto run_compiled_method;
++ }
++
++#run_compiled_method:
++# dbg("rules: run_generic_tests - calling %s", $methodname);
++ my $t = Mail::SpamAssassin::Timeout->new({ deadline => $master_deadline });
++ my $err = $t->run(sub {
++ no strict "refs";
++ $methodname->($pms, @{$opts{args}});
++ });
++ if ($t->timed_out() && $master_deadline && time > $master_deadline) {
++ info("check: exceeded time limit in $methodname, skipping further tests");
++ $pms->{deadline_exceeded} = 1;
+ }
+ }
+
+diff -ur a/Mail-SpamAssassin-3.3.1//lib/Mail/SpamAssassin/Plugin/MIMEEval.pm b/Mail-SpamAssassin-3.3.1//lib/Mail/SpamAssassin/Plugin/MIMEEval.pm
+--- a/Mail-SpamAssassin-3.3.1//lib/Mail/SpamAssassin/Plugin/MIMEEval.pm 2010-03-16 10:49:21.000000000 -0400
++++ b/Mail-SpamAssassin-3.3.1//lib/Mail/SpamAssassin/Plugin/MIMEEval.pm 2010-07-20 16:06:47.000000000 -0400
+@@ -498,7 +498,7 @@
+ # perhaps just limit to test, and image?
+ next if ($ctype eq 'application/ics');
+
+- my $cte = lc $p->get_header('content-transfer-encoding') || '';
++ my $cte = lc($p->get_header('content-transfer-encoding') || '');
+ next if ($cte !~ /^base64$/);
+ foreach my $l ( @{$p->raw()} ) {
+ my $len = length $l;
+Only in b/Mail-SpamAssassin-3.3.1//lib/Mail/SpamAssassin/Plugin: MIMEEval.pm~
diff --git a/mail-filter/spamassassin/metadata.xml b/mail-filter/spamassassin/metadata.xml
new file mode 100644
index 0000000..735796c
--- /dev/null
+++ b/mail-filter/spamassassin/metadata.xml
@@ -0,0 +1,13 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE pkgmetadata SYSTEM "http://www.gentoo.org/dtd/metadata.dtd">
+<pkgmetadata>
+<herd>perl</herd>
+<maintainer>
+ <email>perl@gentoo.org</email>
+ <description>Primary Maintainer</description>
+</maintainer>
+<use>
+ <flag name='qmail'>Build qmail functionality and docs</flag>
+</use>
+</pkgmetadata>
+
diff --git a/mail-filter/spamassassin/spamassassin-3.3.1-r3.ebuild b/mail-filter/spamassassin/spamassassin-3.3.1-r3.ebuild
new file mode 100644
index 0000000..52e15a9
--- /dev/null
+++ b/mail-filter/spamassassin/spamassassin-3.3.1-r3.ebuild
@@ -0,0 +1,202 @@
+# Copyright 1999-2010 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: $
+
+EAPI="2"
+
+inherit perl-module eutils
+
+MY_P=Mail-SpamAssassin-${PV//_/-}
+S=${WORKDIR}/${MY_P}
+DESCRIPTION="SpamAssassin is an extensible email filter which is used to identify spam."
+HOMEPAGE="http://spamassassin.apache.org/"
+SRC_URI="http://apache.osuosl.org/spamassassin/source/${MY_P}.tar.bz2"
+
+LICENSE="Apache-2.0"
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~hppa ~ia64 ~sparc ~x86"
+# need keyword request for Mail-SPF ppc ppc64
+IUSE="berkdb qmail ssl doc ldap mysql postgres sqlite ipv6"
+
+DEPEND=">=dev-lang/perl-5.8.8-r8
+ virtual/perl-MIME-Base64
+ >=virtual/perl-PodParser-1.32
+ virtual/perl-Storable
+ virtual/perl-Time-HiRes
+ >=dev-perl/HTML-Parser-3.43
+ >=dev-perl/Mail-DKIM-0.37
+ >=dev-perl/Net-DNS-0.53
+ dev-perl/Digest-SHA1
+ dev-perl/libwww-perl
+ >=virtual/perl-Archive-Tar-1.26
+ app-crypt/gnupg
+ >=virtual/perl-IO-Zlib-1.04
+ >=dev-util/re2c-0.12.0
+ dev-perl/Mail-SPF
+ dev-perl/NetAddr-IP
+ ssl? (
+ dev-perl/IO-Socket-SSL
+ dev-libs/openssl
+ )
+ berkdb? (
+ virtual/perl-DB_File
+ )
+ ldap? ( dev-perl/perl-ldap )
+ mysql? (
+ dev-perl/DBI
+ dev-perl/DBD-mysql
+ )
+ postgres? (
+ dev-perl/DBI
+ dev-perl/DBD-Pg
+ )
+ sqlite? (
+ dev-perl/DBI
+ dev-perl/DBD-SQLite
+ )
+ ipv6? (
+ dev-perl/IO-Socket-INET6
+ )"
+
+PATCHES=( "${FILESDIR}/${P}-PERL-5-12.patch" )
+
+RDEPEND="${DEPEND}"
+
+# - Disable tests as they will fail
+# - Please see http://www.cpantesters.org/distro/M/Mail-SpamAssassin.html#Mail-SpamAssassin-3.3.1
+# - for more info, upstream problem not specific to Gentoo
+SRC_TEST="skip"
+
+src_configure() {
+ # - Set SYSCONFDIR explicitly so we can't get bitten by bug 48205 again
+ # (just to be sure, nobody knows how it could happen in the first place).
+ myconf="SYSCONFDIR=/etc DATADIR=/usr/share/spamassassin"
+
+ # If ssl is enabled, spamc can be built with ssl support
+ if use ssl; then
+ myconf+=" ENABLE_SSL=yes"
+ else
+ myconf+=" ENABLE_SSL=no"
+ fi
+
+ # Set the path to the Perl executable explictly. This will be used to
+ # create the initial sharpbang line in the scripts and might cause
+ # a versioned app name end in there, see
+ # <http://bugs.gentoo.org/show_bug.cgi?id=62276>
+ myconf+=" PERL_BIN=/usr/bin/perl"
+
+ # Add Gentoo tag to make it easy for the upstream devs to spot
+ # possible modifications or patches.
+ #version_tag="g${PV:6}${PR}"
+ #version_str="${PV//_/-}-${version_tag}"
+
+ # Create the Gentoo config file before Makefile.PL is called so it
+ # is copied later on.
+ #echo "version_tag ${version_tag}" > rules/11_gentoo.cf
+
+ # Setting the following env var ensures that no questions are asked.
+ perl-module_src_configure
+}
+
+src_compile() {
+ export PERL_MM_USE_DEFAULT=1
+ emake spamc/Makefile || die "emake failed"
+
+ # Now compile all the stuff selected.
+ perl-module_src_compile
+
+ if use qmail; then
+ emake spamc/qmail-spamc || die "building qmail-spamc emake failed"
+ fi
+
+}
+
+src_install () {
+ perl-module_src_install
+
+ # Create the stub dir used by sa-update and friends
+ dodir /var/lib/spamassassin || die
+
+ # Move spamd to sbin where it belongs.
+ dodir /usr/sbin
+ mv "${D}"/usr/bin/spamd "${D}"/usr/sbin/spamd || die "move spamd failed"
+
+ if use qmail; then
+ dobin spamc/qmail-spamc || die
+ fi
+
+ dosym /etc/mail/spamassassin /etc/spamassassin || die
+
+ # Disable plugin by default
+ sed -i -e 's/^loadplugin/\#loadplugin/g' "${D}"/etc/mail/spamassassin/init.pre || die
+
+ # Add the init and config scripts.
+ newinitd "${FILESDIR}"/3.3.1-spamd.init spamd || die
+ newconfd "${FILESDIR}"/3.0.0-spamd.conf spamd || die
+
+ use postgres && \
+ sed -i -e 's:@USEPOSTGRES@::' "${D}/etc/init.d/spamd" || \
+ sed -i -e '/@USEPOSTGRES@/d' "${D}/etc/init.d/spamd"
+
+ use mysql && \
+ sed -i -e 's:@USEMYSQL@::' "${D}/etc/init.d/spamd" || \
+ sed -i -e '/@USEMYSQL@/d' "${D}/etc/init.d/spamd"
+
+ dodoc NOTICE TRADEMARK CREDITS INSTALL.VMS UPGRADE USAGE \
+ sql/README.bayes sql/README.awl procmailrc.example sample-nonspam.txt \
+ sample-spam.txt spamassassin.spec spamd/PROTOCOL spamd/README.vpopmail \
+ spamd-apache2/README.apache || die
+
+ # Rename some docu files so they don't clash with others
+ newdoc spamd/README README.spamd || die
+ newdoc sql/README README.sql || die
+ newdoc ldap/README README.ldap || die
+
+ if use qmail; then
+ dodoc spamc/README.qmail || die
+ fi
+
+ cp "${FILESDIR}"/secrets.cf "${D}"/etc/mail/spamassassin/secrets.cf.example || die
+ fperms 0400 /etc/mail/spamassassin/secrets.cf.example
+
+ cat <<EOF > "${T}/local.cf.example"
+# Sensitive data, such as database connection info, should be stored in
+# /etc/mail/spamassassin/secrets.cf with appropriate permissions
+EOF
+
+ insinto /etc/mail/spamassassin/
+ doins "${T}/local.cf.example" || die
+}
+
+pkg_postinst() {
+ perl-module_pkg_postinst
+ elog "If you plan on using the -u flag to spamd, please read the notes"
+ elog "in /etc/conf.d/spamd regarding the location of the pid file.\n"
+ elog "If you build ${PN} with optional dependancy support,"
+ elog "you can enable them in /etc/mail/spamassassin/init.pre\n"
+ elog "You need to configure your database to be able to use Bayes filter"
+ elog "with database backend, otherwise it will still use (and need) the"
+ elog "Berkeley DB support."
+ elog "Look at the sql/README.bayes file in the documentation directory"
+ elog "for how to configure it.\n"
+ elog "If you plan to use Vipul's Razor, note that versions up to and"
+ elog "including version 2.82 include a bug that will slow down the entire"
+ elog "perl interpreter. Version 2.83 or later fixes this."
+ elog "If you do not plan to use this plugin, be sure to comment out"
+ elog "its loadplugin line in /etc/mail/spamassassin/v310.pre.\n"
+ elog "The DKIM plugin is now enabled by default for new installs,"
+ elog "if the perl module Mail::DKIM is installed."
+ elog "However, installation of SpamAssassin will not overwrite existing"
+ elog ".pre configuration files, so to use DKIM when upgrading from a"
+ elog "previous release that did not use DKIM, a directive:\n"
+ elog "loadplugin Mail::SpamAssassin::Plugin::DKIM"
+ elog "will need to be uncommented in file 'v312.pre', or added"
+ elog "to some other .pre file, such as local.pre.\n"
+ ewarn "Rules are no longer included with SpamAssassin out of the box".
+ ewarn "You will need to immediately run sa-update, or download"
+ ewarn "the additional rules .tgz package and run sa-update --install"
+ ewarn "with it, to get a ruleset.\n"
+ elog "If when you run sa-update and receive a GPG validation error."
+ elog "Then you need to import an updated sa-update key."
+ elog "sa-update --import /usr/share/spamassassin/sa-update-pubkey.txt\n"
+}